# coding: utf-8

# flake8: noqa

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

# import apis into sdk package
from swagger_client.api.attributes_api import AttributesApi
from swagger_client.api.authentication_api import AuthenticationApi
from swagger_client.api.comments_api import CommentsApi
from swagger_client.api.containers_api import ContainersApi
from swagger_client.api.data_processing_api import DataProcessingApi
from swagger_client.api.data_processing_item_api import DataProcessingItemApi
from swagger_client.api.fields_api import FieldsApi
from swagger_client.api.filtered_views_api import FilteredViewsApi
from swagger_client.api.glossary_api import GlossaryApi
from swagger_client.api.history_api import HistoryApi
from swagger_client.api.image_api import ImageApi
from swagger_client.api.licenses_api import LicensesApi
from swagger_client.api.links_api import LinksApi
from swagger_client.api.scim_users_api import SCIMUsersApi
from swagger_client.api.screens_api import ScreensApi
from swagger_client.api.search_api import SearchApi
from swagger_client.api.sources_api import SourcesApi
from swagger_client.api.structures_api import StructuresApi
from swagger_client.api.tasks_api import TasksApi
from swagger_client.api.teams_api import TeamsApi
from swagger_client.api.technologies_api import TechnologiesApi
from swagger_client.api.usage_api import UsageApi
from swagger_client.api.users_api import UsersApi
from swagger_client.api.workspaces_api import WorkspacesApi
# import ApiClient
from swagger_client.api_client import ApiClient
from swagger_client.configuration import Configuration
# import models into sdk package
from swagger_client.models.access_data import AccessData
from swagger_client.models.access_type import AccessType
from swagger_client.models.additional_custom_attribute import AdditionalCustomAttribute
from swagger_client.models.additional_custom_attribute_bulk import AdditionalCustomAttributeBulk
from swagger_client.models.all_types import AllTypes
from swagger_client.models.all_types_lower import AllTypesLower
from swagger_client.models.any_of_attribute_bulk_creation_body_default_value import AnyOfAttributeBulkCreationBodyDefaultValue
from swagger_client.models.any_of_attribute_bulk_update_body_default_value import AnyOfAttributeBulkUpdateBodyDefaultValue
from swagger_client.models.any_of_attribute_creation_body_default_value import AnyOfAttributeCreationBodyDefaultValue
from swagger_client.models.any_of_attribute_default_value import AnyOfAttributeDefaultValue
from swagger_client.models.any_of_attribute_update_body_default_value import AnyOfAttributeUpdateBodyDefaultValue
from swagger_client.models.any_of_category_attribute_id import AnyOfCategoryAttributeId
from swagger_client.models.any_of_category_body_attribute_name_id import AnyOfCategoryBodyAttributeNameId
from swagger_client.models.any_of_scim_patch_operation_payload_operations_value import AnyOfSCIMPatchOperationPayloadOperationsValue
from swagger_client.models.any_of_search_filter_values import AnyOfSearchFilterValues
from swagger_client.models.any_of_tags_body_color import AnyOfTagsBodyColor
from swagger_client.models.api_error_model import ApiErrorModel
from swagger_client.models.api_error_model_error import ApiErrorModelError
from swagger_client.models.attribute import Attribute
from swagger_client.models.attribute_bulk_creation_body import AttributeBulkCreationBody
from swagger_client.models.attribute_bulk_update_body import AttributeBulkUpdateBody
from swagger_client.models.attribute_creation_body import AttributeCreationBody
from swagger_client.models.attribute_data_type_enum import AttributeDataTypeEnum
from swagger_client.models.attribute_formats import AttributeFormats
from swagger_client.models.attribute_key import AttributeKey
from swagger_client.models.attribute_name import AttributeName
from swagger_client.models.attribute_update_body import AttributeUpdateBody
from swagger_client.models.attribute_value import AttributeValue
from swagger_client.models.attributes_layout import AttributesLayout
from swagger_client.models.attributes_response_body import AttributesResponseBody
from swagger_client.models.attributes_values_body import AttributesValuesBody
from swagger_client.models.attributes_values_body1 import AttributesValuesBody1
from swagger_client.models.authorizations import Authorizations
from swagger_client.models.authorizations_authorizations import AuthorizationsAuthorizations
from swagger_client.models.bulk_delete_response import BulkDeleteResponse
from swagger_client.models.bulk_input import BulkInput
from swagger_client.models.bulk_links_payload import BulkLinksPayload
from swagger_client.models.bulk_links_result import BulkLinksResult
from swagger_client.models.bulk_result import BulkResult
from swagger_client.models.bulk_tree_creation_request import BulkTreeCreationRequest
from swagger_client.models.category_attribute_ import CategoryAttribute_
from swagger_client.models.category_body_attribute_name_ import CategoryBodyAttributeName_
from swagger_client.models.child_container import ChildContainer
from swagger_client.models.child_structure import ChildStructure
from swagger_client.models.color import Color
from swagger_client.models.column_data_type import ColumnDataType
from swagger_client.models.comment_payload import CommentPayload
from swagger_client.models.compatibility_definition import CompatibilityDefinition
from swagger_client.models.compatible_link import CompatibleLink
from swagger_client.models.container_bulk_creation import ContainerBulkCreation
from swagger_client.models.container_bulk_update import ContainerBulkUpdate
from swagger_client.models.container_creation_request import ContainerCreationRequest
from swagger_client.models.container_type import ContainerType
from swagger_client.models.create_technology_body import CreateTechnologyBody
from swagger_client.models.credentials import Credentials
from swagger_client.models.custom_attribute_name import CustomAttributeName
from swagger_client.models.data_processing_bulk_creation import DataProcessingBulkCreation
from swagger_client.models.data_processing_bulk_response import DataProcessingBulkResponse
from swagger_client.models.data_processing_bulk_response_details import DataProcessingBulkResponseDetails
from swagger_client.models.data_processing_bulk_response_details_data_processing_items import DataProcessingBulkResponseDetailsDataProcessingItems
from swagger_client.models.data_processing_entity import DataProcessingEntity
from swagger_client.models.data_processing_item_type import DataProcessingItemType
from swagger_client.models.data_processing_type import DataProcessingType
from swagger_client.models.data_types import DataTypes
from swagger_client.models.data_types_client_mapping import DataTypesClientMapping
from swagger_client.models.date_iso import DateISO
from swagger_client.models.default_user import DefaultUser
from swagger_client.models.double_uuid import DoubleUuid
from swagger_client.models.dp_creation_request import DpCreationRequest
from swagger_client.models.dp_update_request import DpUpdateRequest
from swagger_client.models.dpi_bulk_model import DpiBulkModel
from swagger_client.models.dpi_creation_body import DpiCreationBody
from swagger_client.models.dpi_data import DpiData
from swagger_client.models.dpi_id import DpiId
from swagger_client.models.dpi_input import DpiInput
from swagger_client.models.dpi_update_body import DpiUpdateBody
from swagger_client.models.email import Email
from swagger_client.models.entity import Entity
from swagger_client.models.entity_attributes import EntityAttributes
from swagger_client.models.entity_base import EntityBase
from swagger_client.models.entity_descriptor import EntityDescriptor
from swagger_client.models.entity_location import EntityLocation
from swagger_client.models.entity_search_result import EntitySearchResult
from swagger_client.models.entity_status import EntityStatus
from swagger_client.models.entity_summary import EntitySummary
from swagger_client.models.exact_match import ExactMatch
from swagger_client.models.exclude_typeof_attribute_data_type_enum_at_keyoftypeof_attribute_data_type_enum_typeof_data_type_enum_dataprocessingitem_ import ExcludeTypeofAttributeDataTypeEnumAtKeyoftypeofAttributeDataTypeEnumTypeofDataTypeEnumDATAPROCESSINGITEM_
from swagger_client.models.field_bulk_creation import FieldBulkCreation
from swagger_client.models.field_bulk_update import FieldBulkUpdate
from swagger_client.models.field_type import FieldType
from swagger_client.models.fields_creation_request import FieldsCreationRequest
from swagger_client.models.fields_update_request import FieldsUpdateRequest
from swagger_client.models.filtered_view import FilteredView
from swagger_client.models.filtered_view_summary import FilteredViewSummary
from swagger_client.models.fk_column import FkColumn
from swagger_client.models.foreign_key import ForeignKey
from swagger_client.models.foreign_key_payload import ForeignKeyPayload
from swagger_client.models.get_technologies_result import GetTechnologiesResult
from swagger_client.models.governance_users import GovernanceUsers
from swagger_client.models.hyper_link import HyperLink
from swagger_client.models.i_attributes import IAttributes
from swagger_client.models.i_date import IDate
from swagger_client.models.image_body import ImageBody
from swagger_client.models.image_hash import ImageHash
from swagger_client.models.image_mime_type import ImageMimeType
from swagger_client.models.image_result import ImageResult
from swagger_client.models.image_upload_response import ImageUploadResponse
from swagger_client.models.include_access_data import IncludeAccessData
from swagger_client.models.include_attributes import IncludeAttributes
from swagger_client.models.include_links import IncludeLinks
from swagger_client.models.inline_response200 import InlineResponse200
from swagger_client.models.inline_response201 import InlineResponse201
from swagger_client.models.integration_token_regeneration_response import IntegrationTokenRegenerationResponse
from swagger_client.models.license import License
from swagger_client.models.license_level import LicenseLevel
from swagger_client.models.license_list import LicenseList
from swagger_client.models.license_report import LicenseReport
from swagger_client.models.linked_entities import LinkedEntities
from swagger_client.models.linked_entity import LinkedEntity
from swagger_client.models.links import Links
from swagger_client.models.links_bulktree_payload import LinksBulktreePayload
from swagger_client.models.links_creation_request import LinksCreationRequest
from swagger_client.models.local_synonym import LocalSynonym
from swagger_client.models.local_synonym_creation_body import LocalSynonymCreationBody
from swagger_client.models.local_synonym_update_body import LocalSynonymUpdateBody
from swagger_client.models.lower_case_all_types import LowerCaseAllTypes
from swagger_client.models.mapping_path import MappingPath
from swagger_client.models.max_depth import MaxDepth
from swagger_client.models.module import Module
from swagger_client.models.module_authorizations import ModuleAuthorizations
from swagger_client.models.module_authorizations_update import ModuleAuthorizationsUpdate
from swagger_client.models.module_names import ModuleNames
from swagger_client.models.module_role import ModuleRole
from swagger_client.models.object_history_entry import ObjectHistoryEntry
from swagger_client.models.object_location import ObjectLocation
from swagger_client.models.objects_history_result import ObjectsHistoryResult
from swagger_client.models.omit_entity_summary_access_data_or_attributes_or_links_or_children_count_ import OmitEntitySummaryAccessDataOrAttributesOrLinksOrChildrenCount_
from swagger_client.models.omit_search_body_included_attributes_or_include_access_data_ import OmitSearchBodyIncludedAttributesOrIncludeAccessData_
from swagger_client.models.omit_team_id_or_icon_hash_or_members_count_ import OmitTeamIdOrIconHashOrMembersCount_
from swagger_client.models.paginated_response_attributes_response_body_ import PaginatedResponseAttributesResponseBody_
from swagger_client.models.paginated_response_dpi_data_ import PaginatedResponseDpiData_
from swagger_client.models.paginated_response_entity_summary_ import PaginatedResponseEntitySummary_
from swagger_client.models.paginated_response_tags_response_body_ import PaginatedResponseTagsResponseBody_
from swagger_client.models.paginated_response_user_authorizations_ import PaginatedResponseUserAuthorizations_
from swagger_client.models.paginated_response_user_ import PaginatedResponseUser_
from swagger_client.models.paginated_response_version_ import PaginatedResponseVersion_
from swagger_client.models.partial_team_creation_payload_ import PartialTeamCreationPayload_
from swagger_client.models.pick_entity_summary_exclude_keyof_entity_summary_access_data_or_attributes_or_links_or_children_count_ import PickEntitySummaryExcludeKeyofEntitySummaryAccessDataOrAttributesOrLinksOrChildrenCount_
from swagger_client.models.pick_entity_summary_exclude_keyof_entity_summary_links_ import PickEntitySummaryExcludeKeyofEntitySummaryLinks_
from swagger_client.models.pick_search_body_exclude_keyof_search_body_included_attributes_or_include_access_data_ import PickSearchBodyExcludeKeyofSearchBodyIncludedAttributesOrIncludeAccessData_
from swagger_client.models.pick_team_exclude_keyof_team_id_or_icon_hash_or_members_count_ import PickTeamExcludeKeyofTeamIdOrIconHashOrMembersCount_
from swagger_client.models.pk_column import PkColumn
from swagger_client.models.primary_key import PrimaryKey
from swagger_client.models.primary_key_payload import PrimaryKeyPayload
from swagger_client.models.properties_bulk_tree_creation_request import PropertiesBulkTreeCreationRequest
from swagger_client.models.property_creation_request import PropertyCreationRequest
from swagger_client.models.property_type import PropertyType
from swagger_client.models.queries_history_result import QueriesHistoryResult
from swagger_client.models.quick_filter import QuickFilter
from swagger_client.models.reference_object import ReferenceObject
from swagger_client.models.reference_parents import ReferenceParents
from swagger_client.models.rich_text import RichText
from swagger_client.models.roles import Roles
from swagger_client.models.scim_error import SCIMError
from swagger_client.models.scim_list_response_user_ import SCIMListResponseUser_
from swagger_client.models.scim_patch_operation_payload import SCIMPatchOperationPayload
from swagger_client.models.scim_patch_operation_payload_operations import SCIMPatchOperationPayloadOperations
from swagger_client.models.scim_user import SCIMUser
from swagger_client.models.scim_user_emails import SCIMUserEmails
from swagger_client.models.scim_user_meta import SCIMUserMeta
from swagger_client.models.scim_user_name import SCIMUserName
from swagger_client.models.scim_user_photos import SCIMUserPhotos
from swagger_client.models.saved_query import SavedQuery
from swagger_client.models.screen_data_types import ScreenDataTypes
from swagger_client.models.search_body import SearchBody
from swagger_client.models.search_filter import SearchFilter
from swagger_client.models.search_filter_operator import SearchFilterOperator
from swagger_client.models.search_query import SearchQuery
from swagger_client.models.search_response import SearchResponse
from swagger_client.models.search_response_result import SearchResponseResult
from swagger_client.models.social_comment import SocialComment
from swagger_client.models.source_bulk_creation import SourceBulkCreation
from swagger_client.models.source_bulk_update import SourceBulkUpdate
from swagger_client.models.source_creation_request import SourceCreationRequest
from swagger_client.models.source_type import SourceType
from swagger_client.models.source_update_request import SourceUpdateRequest
from swagger_client.models.structure_bulk_creation import StructureBulkCreation
from swagger_client.models.structure_bulk_update import StructureBulkUpdate
from swagger_client.models.structure_creation_request import StructureCreationRequest
from swagger_client.models.structure_type import StructureType
from swagger_client.models.structure_update_request import StructureUpdateRequest
from swagger_client.models.system_attribute import SystemAttribute
from swagger_client.models.tags_body import TagsBody
from swagger_client.models.tags_response_body import TagsResponseBody
from swagger_client.models.task import Task
from swagger_client.models.task_creation_payload import TaskCreationPayload
from swagger_client.models.task_status import TaskStatus
from swagger_client.models.task_type import TaskType
from swagger_client.models.task_update_payload import TaskUpdatePayload
from swagger_client.models.team import Team
from swagger_client.models.team_creation_payload import TeamCreationPayload
from swagger_client.models.team_id import TeamId
from swagger_client.models.team_member import TeamMember
from swagger_client.models.team_role import TeamRole
from swagger_client.models.team_update_payload import TeamUpdatePayload
from swagger_client.models.teams_result import TeamsResult
from swagger_client.models.technology import Technology
from swagger_client.models.technology_module import TechnologyModule
from swagger_client.models.time_series_color_rule import TimeSeriesColorRule
from swagger_client.models.time_series_entry import TimeSeriesEntry
from swagger_client.models.time_series_frequency import TimeSeriesFrequency
from swagger_client.models.time_series_value import TimeSeriesValue
from swagger_client.models.url import URL
from swagger_client.models.update_request import UpdateRequest
from swagger_client.models.update_technology_body import UpdateTechnologyBody
from swagger_client.models.usage_bulktree_creation import UsageBulktreeCreation
from swagger_client.models.usage_creation_request import UsageCreationRequest
from swagger_client.models.usage_type import UsageType
from swagger_client.models.usage_update_request import UsageUpdateRequest
from swagger_client.models.user import User
from swagger_client.models.user_authorizations import UserAuthorizations
from swagger_client.models.user_creation_body import UserCreationBody
from swagger_client.models.user_update_authorizations import UserUpdateAuthorizations
from swagger_client.models.user_update_authorizations_definition import UserUpdateAuthorizationsDefinition
from swagger_client.models.user_update_body import UserUpdateBody
from swagger_client.models.users_update_authorizations_body import UsersUpdateAuthorizationsBody
from swagger_client.models.uuid import Uuid
from swagger_client.models.version import Version
from swagger_client.models.version_id import VersionId
from swagger_client.models.workspace import Workspace
from swagger_client.models.workspace_authorization import WorkspaceAuthorization
from swagger_client.models.workspaces import Workspaces
