# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class DataProcessingItemApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def bulk_dpi_creation(self, body, version_id, data_processing_id, **kwargs):  # noqa: E501
        """Bulk upsert data processing items.  # noqa: E501

        Create multiple <b>data processing items</b> and their inputs and outputs in the specified <b>data processing</b>.<br> <b>Inputs</b> and <b>outputs</b> paths must have the following format: <pre><code> {   entityPath: \"\\\\foo\\\\bar\",   typePath: \"\\\\NoSql\\\\Table\" }</code></pre> <br>Available data processing item types can be found thanks to the <code>GET /types</code> endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.bulk_dpi_creation(body, version_id, data_processing_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[DpiBulkModel] body: (required)
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :return: BulkResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.bulk_dpi_creation_with_http_info(body, version_id, data_processing_id, **kwargs)  # noqa: E501
        else:
            (data) = self.bulk_dpi_creation_with_http_info(body, version_id, data_processing_id, **kwargs)  # noqa: E501
            return data

    def bulk_dpi_creation_with_http_info(self, body, version_id, data_processing_id, **kwargs):  # noqa: E501
        """Bulk upsert data processing items.  # noqa: E501

        Create multiple <b>data processing items</b> and their inputs and outputs in the specified <b>data processing</b>.<br> <b>Inputs</b> and <b>outputs</b> paths must have the following format: <pre><code> {   entityPath: \"\\\\foo\\\\bar\",   typePath: \"\\\\NoSql\\\\Table\" }</code></pre> <br>Available data processing item types can be found thanks to the <code>GET /types</code> endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.bulk_dpi_creation_with_http_info(body, version_id, data_processing_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[DpiBulkModel] body: (required)
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :return: BulkResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version_id', 'data_processing_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method bulk_dpi_creation" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `bulk_dpi_creation`")  # noqa: E501
        # verify the required parameter 'version_id' is set
        if ('version_id' not in params or
                params['version_id'] is None):
            raise ValueError("Missing the required parameter `version_id` when calling `bulk_dpi_creation`")  # noqa: E501
        # verify the required parameter 'data_processing_id' is set
        if ('data_processing_id' not in params or
                params['data_processing_id'] is None):
            raise ValueError("Missing the required parameter `data_processing_id` when calling `bulk_dpi_creation`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501
        if 'data_processing_id' in params:
            path_params['dataProcessingId'] = params['data_processing_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/dataProcessingItem/bulk/{versionId}/{dataProcessingId}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='BulkResult',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_dpi(self, body, version_id, data_processing_id, **kwargs):  # noqa: E501
        """Create a data processing item.  # noqa: E501

        Create a <b>data processing item</b> and its inputs and outputs in the specified <b>data processing</b>.<br> An input/output shall be a sourceId/structureId/fieldId. <br>Available data processing item types can be found thanks to the <code>GET /types</code> endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_dpi(body, version_id, data_processing_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DpiCreationBody body: (required)
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :return: DpiId
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_dpi_with_http_info(body, version_id, data_processing_id, **kwargs)  # noqa: E501
        else:
            (data) = self.create_dpi_with_http_info(body, version_id, data_processing_id, **kwargs)  # noqa: E501
            return data

    def create_dpi_with_http_info(self, body, version_id, data_processing_id, **kwargs):  # noqa: E501
        """Create a data processing item.  # noqa: E501

        Create a <b>data processing item</b> and its inputs and outputs in the specified <b>data processing</b>.<br> An input/output shall be a sourceId/structureId/fieldId. <br>Available data processing item types can be found thanks to the <code>GET /types</code> endpoint.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_dpi_with_http_info(body, version_id, data_processing_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DpiCreationBody body: (required)
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :return: DpiId
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version_id', 'data_processing_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_dpi" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_dpi`")  # noqa: E501
        # verify the required parameter 'version_id' is set
        if ('version_id' not in params or
                params['version_id'] is None):
            raise ValueError("Missing the required parameter `version_id` when calling `create_dpi`")  # noqa: E501
        # verify the required parameter 'data_processing_id' is set
        if ('data_processing_id' not in params or
                params['data_processing_id'] is None):
            raise ValueError("Missing the required parameter `data_processing_id` when calling `create_dpi`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501
        if 'data_processing_id' in params:
            path_params['dataProcessingId'] = params['data_processing_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/dataProcessingItem/{versionId}/{dataProcessingId}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DpiId',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_dpi(self, version_id, data_processing_id, data_processing_item_id, **kwargs):  # noqa: E501
        """Delete a data processing item.  # noqa: E501

        Delete a data processing item.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_dpi(version_id, data_processing_id, data_processing_item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :param DoubleUuid data_processing_item_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_dpi_with_http_info(version_id, data_processing_id, data_processing_item_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_dpi_with_http_info(version_id, data_processing_id, data_processing_item_id, **kwargs)  # noqa: E501
            return data

    def delete_dpi_with_http_info(self, version_id, data_processing_id, data_processing_item_id, **kwargs):  # noqa: E501
        """Delete a data processing item.  # noqa: E501

        Delete a data processing item.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_dpi_with_http_info(version_id, data_processing_id, data_processing_item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :param DoubleUuid data_processing_item_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version_id', 'data_processing_id', 'data_processing_item_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_dpi" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version_id' is set
        if ('version_id' not in params or
                params['version_id'] is None):
            raise ValueError("Missing the required parameter `version_id` when calling `delete_dpi`")  # noqa: E501
        # verify the required parameter 'data_processing_id' is set
        if ('data_processing_id' not in params or
                params['data_processing_id'] is None):
            raise ValueError("Missing the required parameter `data_processing_id` when calling `delete_dpi`")  # noqa: E501
        # verify the required parameter 'data_processing_item_id' is set
        if ('data_processing_item_id' not in params or
                params['data_processing_item_id'] is None):
            raise ValueError("Missing the required parameter `data_processing_item_id` when calling `delete_dpi`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501
        if 'data_processing_id' in params:
            path_params['dataProcessingId'] = params['data_processing_id']  # noqa: E501
        if 'data_processing_item_id' in params:
            path_params['dataProcessingItemId'] = params['data_processing_item_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/dataProcessingItem/{versionId}/{dataProcessingId}/{dataProcessingItemId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dpi_list(self, version_id, data_processing_id, **kwargs):  # noqa: E501
        """Return the list of dataProcessingItems contained in the specified data processing.  # noqa: E501

        Return the list of <b>dataProcessingItems</b> contained in the specified <b>data processing</b>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dpi_list(version_id, data_processing_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :param str name:
        :param str technical_name:
        :param DataProcessingItemType type:
        :param float limit:
        :param float page:
        :return: PaginatedResponseDpiData_
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dpi_list_with_http_info(version_id, data_processing_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dpi_list_with_http_info(version_id, data_processing_id, **kwargs)  # noqa: E501
            return data

    def get_dpi_list_with_http_info(self, version_id, data_processing_id, **kwargs):  # noqa: E501
        """Return the list of dataProcessingItems contained in the specified data processing.  # noqa: E501

        Return the list of <b>dataProcessingItems</b> contained in the specified <b>data processing</b>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dpi_list_with_http_info(version_id, data_processing_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :param str name:
        :param str technical_name:
        :param DataProcessingItemType type:
        :param float limit:
        :param float page:
        :return: PaginatedResponseDpiData_
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version_id', 'data_processing_id', 'name', 'technical_name', 'type', 'limit', 'page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dpi_list" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version_id' is set
        if ('version_id' not in params or
                params['version_id'] is None):
            raise ValueError("Missing the required parameter `version_id` when calling `get_dpi_list`")  # noqa: E501
        # verify the required parameter 'data_processing_id' is set
        if ('data_processing_id' not in params or
                params['data_processing_id'] is None):
            raise ValueError("Missing the required parameter `data_processing_id` when calling `get_dpi_list`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'version_id' in params:
            query_params.append(('versionId', params['version_id']))  # noqa: E501
        if 'data_processing_id' in params:
            query_params.append(('dataProcessingId', params['data_processing_id']))  # noqa: E501
        if 'name' in params:
            query_params.append(('name', params['name']))  # noqa: E501
        if 'technical_name' in params:
            query_params.append(('technicalName', params['technical_name']))  # noqa: E501
        if 'type' in params:
            query_params.append(('type', params['type']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/dataProcessingItem', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PaginatedResponseDpiData_',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_types(self, **kwargs):  # noqa: E501
        """List the data processing items types.  # noqa: E501

        Return the list of <b>dataProcessingItem types</b> and their compatible <b>inputs/outputs types</b>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_types(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: list[CompatibilityDefinition]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_types_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_types_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_types_with_http_info(self, **kwargs):  # noqa: E501
        """List the data processing items types.  # noqa: E501

        Return the list of <b>dataProcessingItem types</b> and their compatible <b>inputs/outputs types</b>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_types_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: list[CompatibilityDefinition]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_types" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/dataProcessingItem/types', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CompatibilityDefinition]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_dpi(self, body, version_id, data_processing_id, data_processing_item_id, **kwargs):  # noqa: E501
        """Update a data processing item.  # noqa: E501

        Update a data processing item and its inputs and outputs in the specified data processing.<br> An input/output shall be a sourceId/structureId/fieldId.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_dpi(body, version_id, data_processing_id, data_processing_item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DpiUpdateBody body: (required)
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :param DoubleUuid data_processing_item_id: (required)
        :return: DpiId
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_dpi_with_http_info(body, version_id, data_processing_id, data_processing_item_id, **kwargs)  # noqa: E501
        else:
            (data) = self.update_dpi_with_http_info(body, version_id, data_processing_id, data_processing_item_id, **kwargs)  # noqa: E501
            return data

    def update_dpi_with_http_info(self, body, version_id, data_processing_id, data_processing_item_id, **kwargs):  # noqa: E501
        """Update a data processing item.  # noqa: E501

        Update a data processing item and its inputs and outputs in the specified data processing.<br> An input/output shall be a sourceId/structureId/fieldId.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_dpi_with_http_info(body, version_id, data_processing_id, data_processing_item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DpiUpdateBody body: (required)
        :param VersionId version_id: (required)
        :param DoubleUuid data_processing_id: (required)
        :param DoubleUuid data_processing_item_id: (required)
        :return: DpiId
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version_id', 'data_processing_id', 'data_processing_item_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_dpi" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_dpi`")  # noqa: E501
        # verify the required parameter 'version_id' is set
        if ('version_id' not in params or
                params['version_id'] is None):
            raise ValueError("Missing the required parameter `version_id` when calling `update_dpi`")  # noqa: E501
        # verify the required parameter 'data_processing_id' is set
        if ('data_processing_id' not in params or
                params['data_processing_id'] is None):
            raise ValueError("Missing the required parameter `data_processing_id` when calling `update_dpi`")  # noqa: E501
        # verify the required parameter 'data_processing_item_id' is set
        if ('data_processing_item_id' not in params or
                params['data_processing_item_id'] is None):
            raise ValueError("Missing the required parameter `data_processing_item_id` when calling `update_dpi`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501
        if 'data_processing_id' in params:
            path_params['dataProcessingId'] = params['data_processing_id']  # noqa: E501
        if 'data_processing_item_id' in params:
            path_params['dataProcessingItemId'] = params['data_processing_item_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/dataProcessingItem/{versionId}/{dataProcessingId}/{dataProcessingItemId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DpiId',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
