# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class ScreensApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_attributes_screens(self, **kwargs):  # noqa: E501
        """Return a list of attribute screen layouts  # noqa: E501

        Return a list of attribute screen layouts.<br> An attribute screen layout displays which attributes exists on each entity type, ordered by entity type and categories.<br><br>  Note: there is 2 level of attribute screens: <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130620--basics-manage-the-clientspace\" target=\"_blank\">ClientSpace</a> level and <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130839--basics-administrate-a-workspace\" target=\"_blank\">Workspace</a> level.<br>  Learn more about attribute screen basics with this <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000131901--basics-the-object-card-and-the-screens\" target=\"_blank\">this article</a>. Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  <i>Tip: attribute screen layouts returned by this route are basically a JSON-stringified version of the Screen section <br> found on DataGalaxy Platform.</i>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_attributes_screens(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Uuid version_id: By default, this request will return <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will return <b>workspace</b> level screen layouts.
        :return: list[AttributesLayout]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_attributes_screens_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_attributes_screens_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_attributes_screens_with_http_info(self, **kwargs):  # noqa: E501
        """Return a list of attribute screen layouts  # noqa: E501

        Return a list of attribute screen layouts.<br> An attribute screen layout displays which attributes exists on each entity type, ordered by entity type and categories.<br><br>  Note: there is 2 level of attribute screens: <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130620--basics-manage-the-clientspace\" target=\"_blank\">ClientSpace</a> level and <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130839--basics-administrate-a-workspace\" target=\"_blank\">Workspace</a> level.<br>  Learn more about attribute screen basics with this <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000131901--basics-the-object-card-and-the-screens\" target=\"_blank\">this article</a>. Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  <i>Tip: attribute screen layouts returned by this route are basically a JSON-stringified version of the Screen section <br> found on DataGalaxy Platform.</i>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_attributes_screens_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Uuid version_id: By default, this request will return <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will return <b>workspace</b> level screen layouts.
        :return: list[AttributesLayout]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_attributes_screens" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'version_id' in params:
            query_params.append(('versionId', params['version_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/attributes/screens', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[AttributesLayout]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_attributes_screens_data_type(self, data_type, **kwargs):  # noqa: E501
        """Return a list of attribute screen layouts filtered by dataType  # noqa: E501

        Return a list of attribute screen layouts.<br> An attribute screen layout displays which attributes exists on each entity type, ordered by entity type and categories.<br><br>  Note: there is 2 level of attribute screens: <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130620--basics-manage-the-clientspace\" target=\"_blank\">ClientSpace</a> level and <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130839--basics-administrate-a-workspace\" target=\"_blank\">Workspace</a> level.<br>  Learn more about attribute screen basics with this <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000131901--basics-the-object-card-and-the-screens\" target=\"_blank\">this article</a>. Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  <i>Tip: attribute screen layouts returned by this route are basically a JSON-stringified version of the Screen section <br> found on DataGalaxy Platform.</i>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_attributes_screens_data_type(data_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScreenDataTypes data_type: (required)
        :param Uuid version_id: By default, this request will return <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will return <b>workspace</b> level screen layouts.
        :return: list[AttributesLayout]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_attributes_screens_data_type_with_http_info(data_type, **kwargs)  # noqa: E501
        else:
            (data) = self.get_attributes_screens_data_type_with_http_info(data_type, **kwargs)  # noqa: E501
            return data

    def get_attributes_screens_data_type_with_http_info(self, data_type, **kwargs):  # noqa: E501
        """Return a list of attribute screen layouts filtered by dataType  # noqa: E501

        Return a list of attribute screen layouts.<br> An attribute screen layout displays which attributes exists on each entity type, ordered by entity type and categories.<br><br>  Note: there is 2 level of attribute screens: <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130620--basics-manage-the-clientspace\" target=\"_blank\">ClientSpace</a> level and <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130839--basics-administrate-a-workspace\" target=\"_blank\">Workspace</a> level.<br>  Learn more about attribute screen basics with this <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000131901--basics-the-object-card-and-the-screens\" target=\"_blank\">this article</a>. Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  <i>Tip: attribute screen layouts returned by this route are basically a JSON-stringified version of the Screen section <br> found on DataGalaxy Platform.</i>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_attributes_screens_data_type_with_http_info(data_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScreenDataTypes data_type: (required)
        :param Uuid version_id: By default, this request will return <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will return <b>workspace</b> level screen layouts.
        :return: list[AttributesLayout]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['data_type', 'version_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_attributes_screens_data_type" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'data_type' is set
        if ('data_type' not in params or
                params['data_type'] is None):
            raise ValueError("Missing the required parameter `data_type` when calling `get_attributes_screens_data_type`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'data_type' in params:
            path_params['dataType'] = params['data_type']  # noqa: E501

        query_params = []
        if 'version_id' in params:
            query_params.append(('versionId', params['version_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/attributes/screens/{dataType}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[AttributesLayout]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_attributes_screens_full_types(self, data_type, type, **kwargs):  # noqa: E501
        """Return a list of attribute screen layouts filtered by dataType and entity type  # noqa: E501

        Return a list of attribute screen layouts.<br> An attribute screen layout displays which attributes exists on each entity type, ordered by entity type and categories.<br><br>  Note: there is 2 level of attribute screens: <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130620--basics-manage-the-clientspace\" target=\"_blank\">ClientSpace</a> level and <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130839--basics-administrate-a-workspace\" target=\"_blank\">Workspace</a> level.<br>  Learn more about attribute screen basics with this <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000131901--basics-the-object-card-and-the-screens\" target=\"_blank\">this article</a>. Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  <i>Tip: attribute screen layouts returned by this route are basically a JSON-stringified version of the Screen section <br> found on DataGalaxy Platform.</i>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_attributes_screens_full_types(data_type, type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScreenDataTypes data_type: (required)
        :param LowerCaseAllTypes type: (required)
        :param Uuid version_id: By default, this request will return <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will return <b>workspace</b> level screen layouts.
        :return: list[AttributesLayout]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_attributes_screens_full_types_with_http_info(data_type, type, **kwargs)  # noqa: E501
        else:
            (data) = self.get_attributes_screens_full_types_with_http_info(data_type, type, **kwargs)  # noqa: E501
            return data

    def get_attributes_screens_full_types_with_http_info(self, data_type, type, **kwargs):  # noqa: E501
        """Return a list of attribute screen layouts filtered by dataType and entity type  # noqa: E501

        Return a list of attribute screen layouts.<br> An attribute screen layout displays which attributes exists on each entity type, ordered by entity type and categories.<br><br>  Note: there is 2 level of attribute screens: <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130620--basics-manage-the-clientspace\" target=\"_blank\">ClientSpace</a> level and <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000130839--basics-administrate-a-workspace\" target=\"_blank\">Workspace</a> level.<br>  Learn more about attribute screen basics with this <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000131901--basics-the-object-card-and-the-screens\" target=\"_blank\">this article</a>. Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  <i>Tip: attribute screen layouts returned by this route are basically a JSON-stringified version of the Screen section <br> found on DataGalaxy Platform.</i>  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_attributes_screens_full_types_with_http_info(data_type, type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScreenDataTypes data_type: (required)
        :param LowerCaseAllTypes type: (required)
        :param Uuid version_id: By default, this request will return <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will return <b>workspace</b> level screen layouts.
        :return: list[AttributesLayout]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['data_type', 'type', 'version_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_attributes_screens_full_types" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'data_type' is set
        if ('data_type' not in params or
                params['data_type'] is None):
            raise ValueError("Missing the required parameter `data_type` when calling `get_attributes_screens_full_types`")  # noqa: E501
        # verify the required parameter 'type' is set
        if ('type' not in params or
                params['type'] is None):
            raise ValueError("Missing the required parameter `type` when calling `get_attributes_screens_full_types`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'data_type' in params:
            path_params['dataType'] = params['data_type']  # noqa: E501
        if 'type' in params:
            path_params['type'] = params['type']  # noqa: E501

        query_params = []
        if 'version_id' in params:
            query_params.append(('versionId', params['version_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/attributes/screens/{dataType}/{type}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[AttributesLayout]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def reset_screen(self, data_type, type, **kwargs):  # noqa: E501
        """Reset an Attribute Screen  # noqa: E501

        Reset an attribute screen to its default layout.  Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.reset_screen(data_type, type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScreenDataTypes data_type: Target dataType (required)
        :param LowerCaseAllTypes type: Target entity type (required)
        :param Uuid version_id: By default, this request will reset <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will reset <b>workspace</b> level screen layouts.
        :return: AttributesLayout
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.reset_screen_with_http_info(data_type, type, **kwargs)  # noqa: E501
        else:
            (data) = self.reset_screen_with_http_info(data_type, type, **kwargs)  # noqa: E501
            return data

    def reset_screen_with_http_info(self, data_type, type, **kwargs):  # noqa: E501
        """Reset an Attribute Screen  # noqa: E501

        Reset an attribute screen to its default layout.  Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.reset_screen_with_http_info(data_type, type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ScreenDataTypes data_type: Target dataType (required)
        :param LowerCaseAllTypes type: Target entity type (required)
        :param Uuid version_id: By default, this request will reset <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will reset <b>workspace</b> level screen layouts.
        :return: AttributesLayout
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['data_type', 'type', 'version_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method reset_screen" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'data_type' is set
        if ('data_type' not in params or
                params['data_type'] is None):
            raise ValueError("Missing the required parameter `data_type` when calling `reset_screen`")  # noqa: E501
        # verify the required parameter 'type' is set
        if ('type' not in params or
                params['type'] is None):
            raise ValueError("Missing the required parameter `type` when calling `reset_screen`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'data_type' in params:
            path_params['dataType'] = params['data_type']  # noqa: E501
        if 'type' in params:
            path_params['type'] = params['type']  # noqa: E501

        query_params = []
        if 'version_id' in params:
            query_params.append(('versionId', params['version_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/attributes/screens/{dataType}/{type}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AttributesLayout',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_screen(self, body, data_type, type, **kwargs):  # noqa: E501
        """Update an attribute screen layout  # noqa: E501

        Update an entire attribute screen layout.<br><br>  Here are some tips for your updates: <br> - <b>create a new category</b>: add a new element to your body with just a <code>name</code> and <code>attributes</code><br> - <b>update an existing category</b>: specify its <code>id</code> and change any other property (<code>name</code>, <code>isHidden</code>, <code>attributes</code>)<br> - <b>remove a category</b>: if your body does not contain it, it will be removed<br> - <b>remove an attribute</b>: if <code>attributes</code> does not contain it, it will be removed<br> - <b>change a category or attribute position/order</b>: categories and attributes order in your body will be applied<br><br>  Find existing categories <code>id</code> and layout with <b>GET /attributes/screens</b> routes.<br> Find attribute names with <b>GET /attributes</b>.  Learn more about attribute screen basics with this <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000131901--basics-the-object-card-and-the-screens\" target=\"_blank\">this article</a>. Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_screen(body, data_type, type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[CategoryBodyAttributeName_] body: This represents your screen layout. <b>Categories and attributes order matters</b> (required)
        :param ScreenDataTypes data_type: Target dataType (required)
        :param LowerCaseAllTypes type: Target entity type (required)
        :param Uuid version_id: By default, this request will update <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will update <b>workspace</b> level screen layouts.
        :return: AttributesLayout
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_screen_with_http_info(body, data_type, type, **kwargs)  # noqa: E501
        else:
            (data) = self.update_screen_with_http_info(body, data_type, type, **kwargs)  # noqa: E501
            return data

    def update_screen_with_http_info(self, body, data_type, type, **kwargs):  # noqa: E501
        """Update an attribute screen layout  # noqa: E501

        Update an entire attribute screen layout.<br><br>  Here are some tips for your updates: <br> - <b>create a new category</b>: add a new element to your body with just a <code>name</code> and <code>attributes</code><br> - <b>update an existing category</b>: specify its <code>id</code> and change any other property (<code>name</code>, <code>isHidden</code>, <code>attributes</code>)<br> - <b>remove a category</b>: if your body does not contain it, it will be removed<br> - <b>remove an attribute</b>: if <code>attributes</code> does not contain it, it will be removed<br> - <b>change a category or attribute position/order</b>: categories and attributes order in your body will be applied<br><br>  Find existing categories <code>id</code> and layout with <b>GET /attributes/screens</b> routes.<br> Find attribute names with <b>GET /attributes</b>.  Learn more about attribute screen basics with this <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000131901--basics-the-object-card-and-the-screens\" target=\"_blank\">this article</a>. Learn more about attributes with <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000132213--basics-presentation-of-attributes\" target=\"_blank\">this article</a>.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_screen_with_http_info(body, data_type, type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[CategoryBodyAttributeName_] body: This represents your screen layout. <b>Categories and attributes order matters</b> (required)
        :param ScreenDataTypes data_type: Target dataType (required)
        :param LowerCaseAllTypes type: Target entity type (required)
        :param Uuid version_id: By default, this request will update <b>clientspace</b> level screen layouts.<br> If <code>versionId</code> is specified, this request will update <b>workspace</b> level screen layouts.
        :return: AttributesLayout
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'data_type', 'type', 'version_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_screen" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_screen`")  # noqa: E501
        # verify the required parameter 'data_type' is set
        if ('data_type' not in params or
                params['data_type'] is None):
            raise ValueError("Missing the required parameter `data_type` when calling `update_screen`")  # noqa: E501
        # verify the required parameter 'type' is set
        if ('type' not in params or
                params['type'] is None):
            raise ValueError("Missing the required parameter `type` when calling `update_screen`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'data_type' in params:
            path_params['dataType'] = params['data_type']  # noqa: E501
        if 'type' in params:
            path_params['type'] = params['type']  # noqa: E501

        query_params = []
        if 'version_id' in params:
            query_params.append(('versionId', params['version_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/attributes/screens/{dataType}/{type}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AttributesLayout',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
