# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class SearchApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def search(self, body, **kwargs):  # noqa: E501
        """Search DataGalaxy objects  # noqa: E501

        Search DataGalaxy objects with queries and filters <br>  <h3>Exact Matches</h3> An exact match occure when your <code>query</code> perfectly matches an object's text attribute value.<br>  <h4>Exact match requirements</h4> Attributes have to be indexed for exact match.  <h4>Finding exact matches in the search result</h4>  Exact matches can be determined using the <code>isExactMatch</code> boolean (<code>result.entities[n].isExactMatch</code>).<br> Each search result returned carries this flag.<br>  <h3>Filters</h3> Filters help you refine your search.<br> They are applied to object's attribute values.<br><br> Here is an array documenting which attribute types you can filter and what operators you can use on them:<br>   |              Attribute type              |                                                                                                                  Compatible filter operators                                                                                                                 |  |:----------------------------------------:|:------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------:|  |             Text, Hyperlink, FormattedText |                                                                                            `contains`, `equals`, `startsWith`, `endsWith`, `isEmpty`, `isNotEmpty`                                                                                           |  |                  Boolean                 |                                                                                                                           `equals`                                                                                                                           |  |         Number, TimeSeriesObject         |                                                                  `equals`, `greaterThan`, `lowerThan`, `greaterOrEqualTo`, `lowerThan`, `lowerOrEqualTo`,  `range`, `isEmpty`, `isNotEmpty`                                                                  |  |                   Date                   | `contains`, `pastHour`, `today`, `yesterday`, `currentWeek`, `pastWeek`,  `beforeCurrentWeek`, `beforePastWeek`, `currentMonth`, `pastMonth`, `beforeCurrentMonth`, `beforePastMonth`,  `bedoreToday`, `currentYear`, `last365days`, `isEmpty`, `isNotEmpty` |  |                 ValueList                |                                                                                                               `contains`, `excludes`, `equals`                                                                                                               |  | MultiValueList, Hierarchy, Person, User, ManagedTags  |                                                                                                  `contains`, `isEmpty`, `isNotEmpty`, `matchAll`, `excludes`                                                                                                 |                                                                                                 `contains`, `isEmpty`, `isNotEmpty`, `matchAll`, `excludes`                                                                                                 |  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SearchBody body: (required)
        :return: SearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.search_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.search_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def search_with_http_info(self, body, **kwargs):  # noqa: E501
        """Search DataGalaxy objects  # noqa: E501

        Search DataGalaxy objects with queries and filters <br>  <h3>Exact Matches</h3> An exact match occure when your <code>query</code> perfectly matches an object's text attribute value.<br>  <h4>Exact match requirements</h4> Attributes have to be indexed for exact match.  <h4>Finding exact matches in the search result</h4>  Exact matches can be determined using the <code>isExactMatch</code> boolean (<code>result.entities[n].isExactMatch</code>).<br> Each search result returned carries this flag.<br>  <h3>Filters</h3> Filters help you refine your search.<br> They are applied to object's attribute values.<br><br> Here is an array documenting which attribute types you can filter and what operators you can use on them:<br>   |              Attribute type              |                                                                                                                  Compatible filter operators                                                                                                                 |  |:----------------------------------------:|:------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------:|  |             Text, Hyperlink, FormattedText |                                                                                            `contains`, `equals`, `startsWith`, `endsWith`, `isEmpty`, `isNotEmpty`                                                                                           |  |                  Boolean                 |                                                                                                                           `equals`                                                                                                                           |  |         Number, TimeSeriesObject         |                                                                  `equals`, `greaterThan`, `lowerThan`, `greaterOrEqualTo`, `lowerThan`, `lowerOrEqualTo`,  `range`, `isEmpty`, `isNotEmpty`                                                                  |  |                   Date                   | `contains`, `pastHour`, `today`, `yesterday`, `currentWeek`, `pastWeek`,  `beforeCurrentWeek`, `beforePastWeek`, `currentMonth`, `pastMonth`, `beforeCurrentMonth`, `beforePastMonth`,  `bedoreToday`, `currentYear`, `last365days`, `isEmpty`, `isNotEmpty` |  |                 ValueList                |                                                                                                               `contains`, `excludes`, `equals`                                                                                                               |  | MultiValueList, Hierarchy, Person, User, ManagedTags  |                                                                                                  `contains`, `isEmpty`, `isNotEmpty`, `matchAll`, `excludes`                                                                                                 |                                                                                                 `contains`, `isEmpty`, `isNotEmpty`, `matchAll`, `excludes`                                                                                                 |  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SearchBody body: (required)
        :return: SearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `search`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/search', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SearchResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
