# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class TechnologiesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_techonogy(self, body, **kwargs):  # noqa: E501
        """create_techonogy  # noqa: E501

        Add a custom technology to DataGalaxy using this endpoint.<br>  <h4>Adding technologies to DataGalaxy objects</h4>  Technologies can then be added to an object details using the <code>technologyCode</code> property in a creation or update request payload.<br> Example: <br> <pre><code> POST /sources/bulktree/{versionId} {   \"name\": \"foo\",   \"type\": \"Relational\",   \"technologyCode\": \"azuresql\",   \"children\": [ ... ] } </code></pre>  Read our <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000194800--basics-technologies-overview\" target='_new'>article on technologies</a> for more informations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_techonogy(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateTechnologyBody body: (required)
        :return: Technology
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_techonogy_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_techonogy_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def create_techonogy_with_http_info(self, body, **kwargs):  # noqa: E501
        """create_techonogy  # noqa: E501

        Add a custom technology to DataGalaxy using this endpoint.<br>  <h4>Adding technologies to DataGalaxy objects</h4>  Technologies can then be added to an object details using the <code>technologyCode</code> property in a creation or update request payload.<br> Example: <br> <pre><code> POST /sources/bulktree/{versionId} {   \"name\": \"foo\",   \"type\": \"Relational\",   \"technologyCode\": \"azuresql\",   \"children\": [ ... ] } </code></pre>  Read our <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000194800--basics-technologies-overview\" target='_new'>article on technologies</a> for more informations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_techonogy_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateTechnologyBody body: (required)
        :return: Technology
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_techonogy" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_techonogy`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/technologies', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Technology',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_technology(self, technology_code, **kwargs):  # noqa: E501
        """delete_technology  # noqa: E501

        Delete a technology.<br> Read our <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000194800--basics-technologies-overview\" target='_new'>article on technologies</a> for more informations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_technology(technology_code, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str technology_code: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_technology_with_http_info(technology_code, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_technology_with_http_info(technology_code, **kwargs)  # noqa: E501
            return data

    def delete_technology_with_http_info(self, technology_code, **kwargs):  # noqa: E501
        """delete_technology  # noqa: E501

        Delete a technology.<br> Read our <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000194800--basics-technologies-overview\" target='_new'>article on technologies</a> for more informations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_technology_with_http_info(technology_code, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str technology_code: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['technology_code']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_technology" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'technology_code' is set
        if ('technology_code' not in params or
                params['technology_code'] is None):
            raise ValueError("Missing the required parameter `technology_code` when calling `delete_technology`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'technology_code' in params:
            path_params['technologyCode'] = params['technology_code']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/technologies/{technologyCode}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_technologies(self, **kwargs):  # noqa: E501
        """get_technologies  # noqa: E501

        Use this endpoint in order to fetch Technologies, their associated <i>modules</i>, their <i>description</i>, <i>images</i> and <i>metadatas</i> related to creation, modification and usage.<br> Read our <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000194800--basics-technologies-overview\" target='_new'>article on technologies</a> for more informations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_technologies(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: GetTechnologiesResult
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_technologies_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_technologies_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_technologies_with_http_info(self, **kwargs):  # noqa: E501
        """get_technologies  # noqa: E501

        Use this endpoint in order to fetch Technologies, their associated <i>modules</i>, their <i>description</i>, <i>images</i> and <i>metadatas</i> related to creation, modification and usage.<br> Read our <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000194800--basics-technologies-overview\" target='_new'>article on technologies</a> for more informations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_technologies_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: GetTechnologiesResult
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_technologies" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/technologies', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetTechnologiesResult',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_technology(self, body, technology_code, **kwargs):  # noqa: E501
        """update_technology  # noqa: E501

        Update a technology's <code>displayName</code>, <code>description</code> and associated <code>modules</code> using this endpoint.<br> Read our <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000194800--basics-technologies-overview\" target='_new'>article on technologies</a> for more informations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_technology(body, technology_code, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param UpdateTechnologyBody body: (required)
        :param str technology_code: (required)
        :return: Technology
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_technology_with_http_info(body, technology_code, **kwargs)  # noqa: E501
        else:
            (data) = self.update_technology_with_http_info(body, technology_code, **kwargs)  # noqa: E501
            return data

    def update_technology_with_http_info(self, body, technology_code, **kwargs):  # noqa: E501
        """update_technology  # noqa: E501

        Update a technology's <code>displayName</code>, <code>description</code> and associated <code>modules</code> using this endpoint.<br> Read our <a href=\"https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000194800--basics-technologies-overview\" target='_new'>article on technologies</a> for more informations.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_technology_with_http_info(body, technology_code, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param UpdateTechnologyBody body: (required)
        :param str technology_code: (required)
        :return: Technology
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'technology_code']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_technology" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_technology`")  # noqa: E501
        # verify the required parameter 'technology_code' is set
        if ('technology_code' not in params or
                params['technology_code'] is None):
            raise ValueError("Missing the required parameter `technology_code` when calling `update_technology`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'technology_code' in params:
            path_params['technologyCode'] = params['technology_code']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['AccessToken', 'IntegrationToken']  # noqa: E501

        return self.api_client.call_api(
            '/technologies/{technologyCode}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Technology',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
