# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class EntitySummary(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'DoubleUuid',
        'name': 'str',
        'technical_name': 'str',
        'type': 'str',
        'data_type': 'str',
        'version_id': 'VersionId',
        'path': 'str',
        'type_path': 'str',
        'location': 'ObjectLocation',
        'object_url': 'str',
        'children_count': 'float',
        'access_data': 'AccessData',
        'attributes': 'EntityAttributes',
        'links': 'LinkedEntities',
        'parent': 'EntityBase'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'technical_name': 'technicalName',
        'type': 'type',
        'data_type': 'dataType',
        'version_id': 'versionId',
        'path': 'path',
        'type_path': 'typePath',
        'location': 'location',
        'object_url': 'objectUrl',
        'children_count': 'childrenCount',
        'access_data': 'accessData',
        'attributes': 'attributes',
        'links': 'links',
        'parent': 'parent'
    }

    def __init__(self, id=None, name=None, technical_name=None, type=None, data_type=None, version_id=None, path=None, type_path=None, location=None, object_url=None, children_count=None, access_data=None, attributes=None, links=None, parent=None):  # noqa: E501
        """EntitySummary - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._technical_name = None
        self._type = None
        self._data_type = None
        self._version_id = None
        self._path = None
        self._type_path = None
        self._location = None
        self._object_url = None
        self._children_count = None
        self._access_data = None
        self._attributes = None
        self._links = None
        self._parent = None
        self.discriminator = None
        self.id = id
        self.name = name
        if technical_name is not None:
            self.technical_name = technical_name
        self.type = type
        self.data_type = data_type
        self.version_id = version_id
        self.path = path
        self.type_path = type_path
        self.location = location
        self.object_url = object_url
        if children_count is not None:
            self.children_count = children_count
        if access_data is not None:
            self.access_data = access_data
        if attributes is not None:
            self.attributes = attributes
        if links is not None:
            self.links = links
        if parent is not None:
            self.parent = parent

    @property
    def id(self):
        """Gets the id of this EntitySummary.  # noqa: E501


        :return: The id of this EntitySummary.  # noqa: E501
        :rtype: DoubleUuid
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this EntitySummary.


        :param id: The id of this EntitySummary.  # noqa: E501
        :type: DoubleUuid
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this EntitySummary.  # noqa: E501

        Entity functional name  # noqa: E501

        :return: The name of this EntitySummary.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EntitySummary.

        Entity functional name  # noqa: E501

        :param name: The name of this EntitySummary.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def technical_name(self):
        """Gets the technical_name of this EntitySummary.  # noqa: E501

        Entity technical name  # noqa: E501

        :return: The technical_name of this EntitySummary.  # noqa: E501
        :rtype: str
        """
        return self._technical_name

    @technical_name.setter
    def technical_name(self, technical_name):
        """Sets the technical_name of this EntitySummary.

        Entity technical name  # noqa: E501

        :param technical_name: The technical_name of this EntitySummary.  # noqa: E501
        :type: str
        """

        self._technical_name = technical_name

    @property
    def type(self):
        """Gets the type of this EntitySummary.  # noqa: E501

        Entity type  # noqa: E501

        :return: The type of this EntitySummary.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this EntitySummary.

        Entity type  # noqa: E501

        :param type: The type of this EntitySummary.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def data_type(self):
        """Gets the data_type of this EntitySummary.  # noqa: E501

        Entity dataType  # noqa: E501

        :return: The data_type of this EntitySummary.  # noqa: E501
        :rtype: str
        """
        return self._data_type

    @data_type.setter
    def data_type(self, data_type):
        """Sets the data_type of this EntitySummary.

        Entity dataType  # noqa: E501

        :param data_type: The data_type of this EntitySummary.  # noqa: E501
        :type: str
        """
        if data_type is None:
            raise ValueError("Invalid value for `data_type`, must not be `None`")  # noqa: E501

        self._data_type = data_type

    @property
    def version_id(self):
        """Gets the version_id of this EntitySummary.  # noqa: E501


        :return: The version_id of this EntitySummary.  # noqa: E501
        :rtype: VersionId
        """
        return self._version_id

    @version_id.setter
    def version_id(self, version_id):
        """Sets the version_id of this EntitySummary.


        :param version_id: The version_id of this EntitySummary.  # noqa: E501
        :type: VersionId
        """
        if version_id is None:
            raise ValueError("Invalid value for `version_id`, must not be `None`")  # noqa: E501

        self._version_id = version_id

    @property
    def path(self):
        """Gets the path of this EntitySummary.  # noqa: E501

        Path to entity. Composed of entity's parents technical names  # noqa: E501

        :return: The path of this EntitySummary.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this EntitySummary.

        Path to entity. Composed of entity's parents technical names  # noqa: E501

        :param path: The path of this EntitySummary.  # noqa: E501
        :type: str
        """
        if path is None:
            raise ValueError("Invalid value for `path`, must not be `None`")  # noqa: E501

        self._path = path

    @property
    def type_path(self):
        """Gets the type_path of this EntitySummary.  # noqa: E501

        Path to entity. Composed of entity's parents types  # noqa: E501

        :return: The type_path of this EntitySummary.  # noqa: E501
        :rtype: str
        """
        return self._type_path

    @type_path.setter
    def type_path(self, type_path):
        """Sets the type_path of this EntitySummary.

        Path to entity. Composed of entity's parents types  # noqa: E501

        :param type_path: The type_path of this EntitySummary.  # noqa: E501
        :type: str
        """
        if type_path is None:
            raise ValueError("Invalid value for `type_path`, must not be `None`")  # noqa: E501

        self._type_path = type_path

    @property
    def location(self):
        """Gets the location of this EntitySummary.  # noqa: E501


        :return: The location of this EntitySummary.  # noqa: E501
        :rtype: ObjectLocation
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this EntitySummary.


        :param location: The location of this EntitySummary.  # noqa: E501
        :type: ObjectLocation
        """
        if location is None:
            raise ValueError("Invalid value for `location`, must not be `None`")  # noqa: E501

        self._location = location

    @property
    def object_url(self):
        """Gets the object_url of this EntitySummary.  # noqa: E501

        Object URL in DataGalaxy's web application  # noqa: E501

        :return: The object_url of this EntitySummary.  # noqa: E501
        :rtype: str
        """
        return self._object_url

    @object_url.setter
    def object_url(self, object_url):
        """Sets the object_url of this EntitySummary.

        Object URL in DataGalaxy's web application  # noqa: E501

        :param object_url: The object_url of this EntitySummary.  # noqa: E501
        :type: str
        """
        if object_url is None:
            raise ValueError("Invalid value for `object_url`, must not be `None`")  # noqa: E501

        self._object_url = object_url

    @property
    def children_count(self):
        """Gets the children_count of this EntitySummary.  # noqa: E501

        Total number of descendants the current entity has  # noqa: E501

        :return: The children_count of this EntitySummary.  # noqa: E501
        :rtype: float
        """
        return self._children_count

    @children_count.setter
    def children_count(self, children_count):
        """Sets the children_count of this EntitySummary.

        Total number of descendants the current entity has  # noqa: E501

        :param children_count: The children_count of this EntitySummary.  # noqa: E501
        :type: float
        """

        self._children_count = children_count

    @property
    def access_data(self):
        """Gets the access_data of this EntitySummary.  # noqa: E501


        :return: The access_data of this EntitySummary.  # noqa: E501
        :rtype: AccessData
        """
        return self._access_data

    @access_data.setter
    def access_data(self, access_data):
        """Sets the access_data of this EntitySummary.


        :param access_data: The access_data of this EntitySummary.  # noqa: E501
        :type: AccessData
        """

        self._access_data = access_data

    @property
    def attributes(self):
        """Gets the attributes of this EntitySummary.  # noqa: E501


        :return: The attributes of this EntitySummary.  # noqa: E501
        :rtype: EntityAttributes
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this EntitySummary.


        :param attributes: The attributes of this EntitySummary.  # noqa: E501
        :type: EntityAttributes
        """

        self._attributes = attributes

    @property
    def links(self):
        """Gets the links of this EntitySummary.  # noqa: E501


        :return: The links of this EntitySummary.  # noqa: E501
        :rtype: LinkedEntities
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this EntitySummary.


        :param links: The links of this EntitySummary.  # noqa: E501
        :type: LinkedEntities
        """

        self._links = links

    @property
    def parent(self):
        """Gets the parent of this EntitySummary.  # noqa: E501


        :return: The parent of this EntitySummary.  # noqa: E501
        :rtype: EntityBase
        """
        return self._parent

    @parent.setter
    def parent(self, parent):
        """Sets the parent of this EntitySummary.


        :param parent: The parent of this EntitySummary.  # noqa: E501
        :type: EntityBase
        """

        self._parent = parent

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EntitySummary, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EntitySummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
