# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FilteredView(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'id': 'float',
        'owner_user_id': 'Uuid',
        'workspace_id': 'DoubleUuid',
        'default_version_id': 'Uuid',
        'is_favorite': 'bool',
        'is_private': 'bool',
        'creation_time': 'str',
        'last_modification_time': 'str',
        'filters': 'list[SearchFilter]'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'owner_user_id': 'ownerUserId',
        'workspace_id': 'workspaceId',
        'default_version_id': 'defaultVersionId',
        'is_favorite': 'isFavorite',
        'is_private': 'isPrivate',
        'creation_time': 'creationTime',
        'last_modification_time': 'lastModificationTime',
        'filters': 'filters'
    }

    def __init__(self, name=None, id=None, owner_user_id=None, workspace_id=None, default_version_id=None, is_favorite=None, is_private=None, creation_time=None, last_modification_time=None, filters=None):  # noqa: E501
        """FilteredView - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._id = None
        self._owner_user_id = None
        self._workspace_id = None
        self._default_version_id = None
        self._is_favorite = None
        self._is_private = None
        self._creation_time = None
        self._last_modification_time = None
        self._filters = None
        self.discriminator = None
        self.name = name
        self.id = id
        self.owner_user_id = owner_user_id
        self.workspace_id = workspace_id
        self.default_version_id = default_version_id
        self.is_favorite = is_favorite
        self.is_private = is_private
        self.creation_time = creation_time
        self.last_modification_time = last_modification_time
        self.filters = filters

    @property
    def name(self):
        """Gets the name of this FilteredView.  # noqa: E501


        :return: The name of this FilteredView.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FilteredView.


        :param name: The name of this FilteredView.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def id(self):
        """Gets the id of this FilteredView.  # noqa: E501


        :return: The id of this FilteredView.  # noqa: E501
        :rtype: float
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FilteredView.


        :param id: The id of this FilteredView.  # noqa: E501
        :type: float
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def owner_user_id(self):
        """Gets the owner_user_id of this FilteredView.  # noqa: E501


        :return: The owner_user_id of this FilteredView.  # noqa: E501
        :rtype: Uuid
        """
        return self._owner_user_id

    @owner_user_id.setter
    def owner_user_id(self, owner_user_id):
        """Sets the owner_user_id of this FilteredView.


        :param owner_user_id: The owner_user_id of this FilteredView.  # noqa: E501
        :type: Uuid
        """
        if owner_user_id is None:
            raise ValueError("Invalid value for `owner_user_id`, must not be `None`")  # noqa: E501

        self._owner_user_id = owner_user_id

    @property
    def workspace_id(self):
        """Gets the workspace_id of this FilteredView.  # noqa: E501


        :return: The workspace_id of this FilteredView.  # noqa: E501
        :rtype: DoubleUuid
        """
        return self._workspace_id

    @workspace_id.setter
    def workspace_id(self, workspace_id):
        """Sets the workspace_id of this FilteredView.


        :param workspace_id: The workspace_id of this FilteredView.  # noqa: E501
        :type: DoubleUuid
        """
        if workspace_id is None:
            raise ValueError("Invalid value for `workspace_id`, must not be `None`")  # noqa: E501

        self._workspace_id = workspace_id

    @property
    def default_version_id(self):
        """Gets the default_version_id of this FilteredView.  # noqa: E501


        :return: The default_version_id of this FilteredView.  # noqa: E501
        :rtype: Uuid
        """
        return self._default_version_id

    @default_version_id.setter
    def default_version_id(self, default_version_id):
        """Sets the default_version_id of this FilteredView.


        :param default_version_id: The default_version_id of this FilteredView.  # noqa: E501
        :type: Uuid
        """
        if default_version_id is None:
            raise ValueError("Invalid value for `default_version_id`, must not be `None`")  # noqa: E501

        self._default_version_id = default_version_id

    @property
    def is_favorite(self):
        """Gets the is_favorite of this FilteredView.  # noqa: E501


        :return: The is_favorite of this FilteredView.  # noqa: E501
        :rtype: bool
        """
        return self._is_favorite

    @is_favorite.setter
    def is_favorite(self, is_favorite):
        """Sets the is_favorite of this FilteredView.


        :param is_favorite: The is_favorite of this FilteredView.  # noqa: E501
        :type: bool
        """
        if is_favorite is None:
            raise ValueError("Invalid value for `is_favorite`, must not be `None`")  # noqa: E501

        self._is_favorite = is_favorite

    @property
    def is_private(self):
        """Gets the is_private of this FilteredView.  # noqa: E501


        :return: The is_private of this FilteredView.  # noqa: E501
        :rtype: bool
        """
        return self._is_private

    @is_private.setter
    def is_private(self, is_private):
        """Sets the is_private of this FilteredView.


        :param is_private: The is_private of this FilteredView.  # noqa: E501
        :type: bool
        """
        if is_private is None:
            raise ValueError("Invalid value for `is_private`, must not be `None`")  # noqa: E501

        self._is_private = is_private

    @property
    def creation_time(self):
        """Gets the creation_time of this FilteredView.  # noqa: E501


        :return: The creation_time of this FilteredView.  # noqa: E501
        :rtype: str
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """Sets the creation_time of this FilteredView.


        :param creation_time: The creation_time of this FilteredView.  # noqa: E501
        :type: str
        """
        if creation_time is None:
            raise ValueError("Invalid value for `creation_time`, must not be `None`")  # noqa: E501

        self._creation_time = creation_time

    @property
    def last_modification_time(self):
        """Gets the last_modification_time of this FilteredView.  # noqa: E501


        :return: The last_modification_time of this FilteredView.  # noqa: E501
        :rtype: str
        """
        return self._last_modification_time

    @last_modification_time.setter
    def last_modification_time(self, last_modification_time):
        """Sets the last_modification_time of this FilteredView.


        :param last_modification_time: The last_modification_time of this FilteredView.  # noqa: E501
        :type: str
        """
        if last_modification_time is None:
            raise ValueError("Invalid value for `last_modification_time`, must not be `None`")  # noqa: E501

        self._last_modification_time = last_modification_time

    @property
    def filters(self):
        """Gets the filters of this FilteredView.  # noqa: E501


        :return: The filters of this FilteredView.  # noqa: E501
        :rtype: list[SearchFilter]
        """
        return self._filters

    @filters.setter
    def filters(self, filters):
        """Sets the filters of this FilteredView.


        :param filters: The filters of this FilteredView.  # noqa: E501
        :type: list[SearchFilter]
        """
        if filters is None:
            raise ValueError("Invalid value for `filters`, must not be `None`")  # noqa: E501

        self._filters = filters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FilteredView, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FilteredView):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
