# coding: utf-8

"""
    Developer API - DataGalaxy

    # Overview  The DataGalaxy API gives you access to CRUD actions on your metamodel, users and licenses.  Our API is organized around REST. It accepts and returns JSON-encoded data, and uses standard HTTP response codes, verbs and authentication with access tokens.  To get the full picture of DataGalaxy, please feel free to consult our <a href='https://datagalaxy.freshdesk.com/solution/articles/35000131583--basics-datagalaxy-s-main-concepts-/en' target='_new'>online documentation.</a><br/> Have a look at our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>step by step guide</a> for a quick start on how to use our API.  ## Response Status Codes  | Status Code  | Description       | Notes | | ------------ | ----------------- | ----- | | 200          | OK                | The request was successful | | 400          | Bad Request       | Incoming request contains parameters that might not be valid | | 401          | Unauthorized      | The supplied credentials, if any, are not sufficient to access the resource | | 404          | Not Found         | The requested resource is not found | | 429          | Too Many Requests | Too many requests have been (Rate limiting) | | 500          | Server Error      | The server could not return the representation due to an internal server error | | 501          | Not Implemented   | The requested operation is not supported (e.g. supports GET but not POST etc.) |  ## Rate Limits  The DataGalaxy API has 2 kinds of limitations: rate limiting and throttling.  <b>Pro tip:</b> You can track your rate limiting status with the response header `X-RateLimit-Remaining`. It will display how many requests you can send until the next reset.  | Method        | Rate                 | Note | | ------------- | -------------------- | ---- | | Rate limiting | 7200 requests / hour | When exceeded, your IP will be blocked for 15 minutes. | | Throttling    | 2 requests / second  | When exceeded, each request will be delayed by 500ms. | | Payload size  | 100 MB               | When exceeded, request will be rejected. |  ## Pagination  All routes returning lists share the same pagination format. These routes take two optional parameters as querystrings: <code>limit</code> and <code>page</code>.<br>  | QueryString | Definition | |------------ | ---------- | | limit       | Integer ranging from 1 to 5000. It sets the maximum amount of objects per page. Default value is 20. | | page        | Integer starting at 1. It determines the page returned by the request. Default value is 1. |  The response payload contains 5 properties:  | Property  | Definition | | --------- | ---------- | | pages     | Total number of pages. | | total     | Number of objects returned. | | total_sum | Sum of all existing objects. | | next_page | URL of the next page. <i>Value will be null if there is none.</i> | | results   | List of objects. |  # Authentication  The DataGalaxy API uses <b>Bearer Authentication</b> to authenticate requests. Every request must contain an <code>Authorization</code> header with, either an <i>AccessToken</i> or an <i>IntegrationToken</i>.  ## AccessToken  Here is a quick example using CURL:  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>AccessToken</i>\"</code></pre>  The first steps of our <a href='https://datagalaxy.freshdesk.com/en/support/solutions/articles/35000151096--quick-start-datagalaxy-public-api-v2' target='_new'>quick start guide</a> will give you instructions to obtain your <code>accesstoken</code>.  ## IntegrationToken  An integration token can be generated from the \"Integration\" page on the DataGalaxy Administration space.  <pre><code>curl -X GET \"https://api.datagalaxy.com/v2/workspaces\" -H \"Authorization: Bearer <i>IntegrationToken</i>\"</code></pre>  # Changelog  The DataGalaxy Developer API is updated frequently with new features, improvements and fixes.  All these changes will be documented in our <button><a href='/v2/documentation/changelog' target='_blank'><b>changelog</b></a></button>.  # Documentation layout  We provide two API documentation layouts:  - [Default layout](/v2/documentation)<br> This layout displays informations in a modern way and contains more informations about requests parameters - [Swagger layout](/v2/documentation/old)<br> This is our legacy layout. It's main perk is the \"Try it\" feature which let's you send requests directly from the documentation.  # noqa: E501

    OpenAPI spec version: 2.12.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Version(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'workspace_name': 'str',
        'version_name': 'str',
        'origin_version_id': 'VersionId',
        'origin_version_name': 'str',
        'is_default_version': 'bool',
        'version_id': 'VersionId'
    }

    attribute_map = {
        'workspace_name': 'workspaceName',
        'version_name': 'versionName',
        'origin_version_id': 'originVersionId',
        'origin_version_name': 'originVersionName',
        'is_default_version': 'isDefaultVersion',
        'version_id': 'versionId'
    }

    def __init__(self, workspace_name=None, version_name=None, origin_version_id=None, origin_version_name=None, is_default_version=None, version_id=None):  # noqa: E501
        """Version - a model defined in Swagger"""  # noqa: E501
        self._workspace_name = None
        self._version_name = None
        self._origin_version_id = None
        self._origin_version_name = None
        self._is_default_version = None
        self._version_id = None
        self.discriminator = None
        self.workspace_name = workspace_name
        self.version_name = version_name
        self.origin_version_id = origin_version_id
        self.origin_version_name = origin_version_name
        self.is_default_version = is_default_version
        self.version_id = version_id

    @property
    def workspace_name(self):
        """Gets the workspace_name of this Version.  # noqa: E501


        :return: The workspace_name of this Version.  # noqa: E501
        :rtype: str
        """
        return self._workspace_name

    @workspace_name.setter
    def workspace_name(self, workspace_name):
        """Sets the workspace_name of this Version.


        :param workspace_name: The workspace_name of this Version.  # noqa: E501
        :type: str
        """
        if workspace_name is None:
            raise ValueError("Invalid value for `workspace_name`, must not be `None`")  # noqa: E501

        self._workspace_name = workspace_name

    @property
    def version_name(self):
        """Gets the version_name of this Version.  # noqa: E501


        :return: The version_name of this Version.  # noqa: E501
        :rtype: str
        """
        return self._version_name

    @version_name.setter
    def version_name(self, version_name):
        """Sets the version_name of this Version.


        :param version_name: The version_name of this Version.  # noqa: E501
        :type: str
        """
        if version_name is None:
            raise ValueError("Invalid value for `version_name`, must not be `None`")  # noqa: E501

        self._version_name = version_name

    @property
    def origin_version_id(self):
        """Gets the origin_version_id of this Version.  # noqa: E501


        :return: The origin_version_id of this Version.  # noqa: E501
        :rtype: VersionId
        """
        return self._origin_version_id

    @origin_version_id.setter
    def origin_version_id(self, origin_version_id):
        """Sets the origin_version_id of this Version.


        :param origin_version_id: The origin_version_id of this Version.  # noqa: E501
        :type: VersionId
        """
        if origin_version_id is None:
            raise ValueError("Invalid value for `origin_version_id`, must not be `None`")  # noqa: E501

        self._origin_version_id = origin_version_id

    @property
    def origin_version_name(self):
        """Gets the origin_version_name of this Version.  # noqa: E501


        :return: The origin_version_name of this Version.  # noqa: E501
        :rtype: str
        """
        return self._origin_version_name

    @origin_version_name.setter
    def origin_version_name(self, origin_version_name):
        """Sets the origin_version_name of this Version.


        :param origin_version_name: The origin_version_name of this Version.  # noqa: E501
        :type: str
        """
        if origin_version_name is None:
            raise ValueError("Invalid value for `origin_version_name`, must not be `None`")  # noqa: E501

        self._origin_version_name = origin_version_name

    @property
    def is_default_version(self):
        """Gets the is_default_version of this Version.  # noqa: E501


        :return: The is_default_version of this Version.  # noqa: E501
        :rtype: bool
        """
        return self._is_default_version

    @is_default_version.setter
    def is_default_version(self, is_default_version):
        """Sets the is_default_version of this Version.


        :param is_default_version: The is_default_version of this Version.  # noqa: E501
        :type: bool
        """
        if is_default_version is None:
            raise ValueError("Invalid value for `is_default_version`, must not be `None`")  # noqa: E501

        self._is_default_version = is_default_version

    @property
    def version_id(self):
        """Gets the version_id of this Version.  # noqa: E501


        :return: The version_id of this Version.  # noqa: E501
        :rtype: VersionId
        """
        return self._version_id

    @version_id.setter
    def version_id(self, version_id):
        """Sets the version_id of this Version.


        :param version_id: The version_id of this Version.  # noqa: E501
        :type: VersionId
        """
        if version_id is None:
            raise ValueError("Invalid value for `version_id`, must not be `None`")  # noqa: E501

        self._version_id = version_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Version, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Version):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
